package com.goldencode.hotel.dmo._meta.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;
import com.goldencode.hotel.dmo._meta.*;

/**
 * Data Model Object corresponding with table <code>_meta.meta_field</code> (previously
 * <code>_meta._field</code>).
 */
@LegacyTable(name = "_field", table = "meta_field")
@LegacyIndexes(
{
   @LegacyIndex(name = "_file/field", converted = "meta_field_file_field", primary = true, unique = true, components = 
   {
      @LegacyIndexComponent(fieldName = "_file-recid"),
      @LegacyIndexComponent(fieldName = "_field-name")
   }),
   @LegacyIndex(name = "_field-name", converted = "meta_field_field_name", unique = true, components = 
   {
      @LegacyIndexComponent(fieldName = "_field-name"),
      @LegacyIndexComponent(fieldName = "_file-recid")
   }),
   @LegacyIndex(name = "_field-position", converted = "meta_field_field_position", unique = true, components = 
   {
      @LegacyIndexComponent(fieldName = "_file-recid"),
      @LegacyIndexComponent(fieldName = "_order")
   }),
   @LegacyIndex(name = "_fieldphyspos", converted = "meta_field_fieldphyspos", unique = true, components = 
   {
      @LegacyIndexComponent(fieldName = "_file-recid"),
      @LegacyIndexComponent(fieldName = "_field-physpos")
   })
})
public class MetaFieldImpl
implements Serializable,
           Persistable,
           MetaField
{
   /** Surrogate primary key */
   private Long id = null;

   /** Data member */
   @LegacyField(fieldId = 1, name = "_new-name", format = "x(32)", initial = "?", mandatory = true, order = -1)
   private final character newName;

   /** File-recid */
   @LegacyField(fieldId = 2, name = "_file-recid", format = ">>>>>>>9", initial = "?", label = "File-recid", mandatory = true, order = 2)
   private final recid fileRecid;

   /** Field-Name */
   @LegacyField(fieldId = 3, name = "_field-name", format = "x(32)", initial = "?", label = "Field-Name", mandatory = true, order = 3)
   private final character fieldName;

   /** Data-Type */
   @LegacyField(fieldId = 4, name = "_data-type", format = "x(9)", initial = "?", label = "Data-Type", mandatory = true, order = 4)
   private final character dataType;

   /** Data member */
   @LegacyField(fieldId = 5, name = "_dtype", format = ">>9", initial = "?", order = 5)
   private final integer dtype;

   /** Initial */
   @LegacyField(fieldId = 6, name = "_initial", format = "x(30)", initial = "?", label = "Initial", order = 6, caseSensitive = true)
   private final character initial;

   /** Label */
   @LegacyField(fieldId = 7, name = "_label", format = "x(30)", initial = "?", label = "Label", order = 7, caseSensitive = true)
   private final character label;

   /** Mandatory */
   @LegacyField(fieldId = 8, name = "_mandatory", format = "yes/no", initial = "false", label = "Mandatory", mandatory = true, order = 8)
   private final logical mandatory;

   /** Format */
   @LegacyField(fieldId = 9, name = "_format", format = "x(30)", initial = "?", label = "Format", mandatory = true, order = 9)
   private final character format;

   /** Data member */
   @LegacyField(fieldId = 10, name = "_sys-field", format = "yes/no", initial = "false", order = 10)
   private final logical sysField;

   /** field-rpos */
   @LegacyField(fieldId = 11, name = "_field-rpos", format = ">>9", initial = "?", label = "field-rpos", order = 11)
   private final integer fieldRpos;

   /** Decimals */
   @LegacyField(fieldId = 12, name = "_decimals", format = ">>>9", initial = "?", label = "Decimals", order = 12)
   private final integer decimals;

   /** Order */
   @LegacyField(fieldId = 13, name = "_order", format = ">>>9", initial = "?", label = "Order", mandatory = true, order = 13)
   private final integer order;

   /** Can-Read */
   @LegacyField(fieldId = 14, name = "_can-read", format = "x(63)", initial = "*", label = "Can-Read", mandatory = true, order = 14)
   private final character canRead;

   /** Can-Write */
   @LegacyField(fieldId = 15, name = "_can-write", format = "x(63)", initial = "*", label = "Can-Write", mandatory = true, order = 15)
   private final character canWrite;

   /** Extent */
   @LegacyField(fieldId = 16, name = "_extent", format = ">>>9", initial = "0", label = "Extent", mandatory = true, order = 16)
   private final integer extent;

   /** Valexp */
   @LegacyField(fieldId = 17, name = "_valexp", format = "x(72)", initial = "?", label = "Valexp", order = 17)
   private final character valexp;

   /** Valmsg */
   @LegacyField(fieldId = 18, name = "_valmsg", format = "x(72)", label = "Valmsg", order = 18, caseSensitive = true)
   private final character valmsg;

   /** Help */
   @LegacyField(fieldId = 19, name = "_help", format = "x(63)", label = "Help", order = 19, caseSensitive = true)
   private final character help;

   /** Desc */
   @LegacyField(fieldId = 20, name = "_desc", format = "x(72)", label = "Desc", order = 20, caseSensitive = true)
   private final character desc;

   /** Col-label */
   @LegacyField(fieldId = 21, name = "_col-label", format = "x(30)", initial = "?", label = "Col-label", order = 21, caseSensitive = true)
   private final character colLabel;

   /** Data member */
   @LegacyField(fieldId = 22, name = "_fld-stdtype", format = ">>9", initial = "?", order = 22)
   private final integer fldStdtype;

   /** Data member */
   @LegacyField(fieldId = 23, name = "_fld-stlen", format = ">>9", initial = "?", order = 23)
   private final integer fldStlen;

   /** Data member */
   @LegacyField(fieldId = 24, name = "_fld-stoff", format = ">>9", initial = "?", order = 24)
   private final integer fldStoff;

   /** Fld-case */
   @LegacyField(fieldId = 27, name = "_fld-case", format = "yes/no", initial = "false", label = "Fld-case", mandatory = true, order = 27)
   private final logical fldCase;

   /** Data member */
   @LegacyField(fieldId = 30, name = "_for-id", format = ">>>>9", initial = "?", order = 30)
   private final integer forId;

   /** Data member */
   @LegacyField(fieldId = 31, name = "_for-primary", format = ">>>9", initial = "?", order = 31)
   private final integer forPrimary;

   /** Data member */
   @LegacyField(fieldId = 32, name = "_for-spacing", format = ">>>9", initial = "?", order = 32)
   private final integer forSpacing;

   /** Data member */
   @LegacyField(fieldId = 33, name = "_for-scale", format = ">>>9", initial = "?", order = 33)
   private final integer forScale;

   /** Data member */
   @LegacyField(fieldId = 34, name = "_for-name", format = "x(32)", initial = "?", order = 34)
   private final character forName;

   /** Data member */
   @LegacyField(fieldId = 35, name = "_for-type", format = "x(12)", initial = "?", order = 35)
   private final character forType;

   /** Data member */
   @LegacyField(fieldId = 36, name = "_for-itype", format = ">>>>9", initial = "?", order = 36)
   private final integer forItype;

   /** Data member */
   @LegacyField(fieldId = 37, name = "_for-xpos", format = ">>>>9", initial = "?", order = 37)
   private final integer forXpos;

   /** Data member */
   @LegacyField(fieldId = 38, name = "_for-retrieve", format = "yes/no", initial = "?", order = 38)
   private final logical forRetrieve;

   /** Data member */
   @LegacyField(fieldId = 39, name = "_for-separator", format = "x(1)", initial = "?", order = 39)
   private final character forSeparator;

   /** Data member */
   @LegacyField(fieldId = 40, name = "_for-maxsize", format = ">>>>>>>9", initial = "?", order = 40)
   private final integer forMaxsize;

   /** Data member */
   @LegacyField(fieldId = 41, name = "_for-allocated", format = ">>>>>>>9", initial = "?", order = 41)
   private final integer forAllocated;

   /** View-As */
   @LegacyField(fieldId = 42, name = "_view-as", format = "x(50)", initial = "?", label = "View-As", order = 42)
   private final character viewAs;

   /** Initial-SA */
   @LegacyField(fieldId = 43, name = "_initial-sa", format = "x(6)", initial = "?", label = "Initial-SA", order = 43)
   private final character initialSa;

   /** Label-SA */
   @LegacyField(fieldId = 44, name = "_label-sa", format = "x(6)", initial = "?", label = "Label-SA", order = 44)
   private final character labelSa;

   /** Format-SA */
   @LegacyField(fieldId = 45, name = "_format-sa", format = "x(6)", initial = "?", label = "Format-SA", order = 45)
   private final character formatSa;

   /** Valmsg-SA */
   @LegacyField(fieldId = 46, name = "_valmsg-sa", format = "x(6)", label = "Valmsg-SA", order = 46)
   private final character valmsgSa;

   /** Help-SA */
   @LegacyField(fieldId = 47, name = "_help-sa", format = "x(6)", label = "Help-SA", order = 47)
   private final character helpSa;

   /** Col-label-SA */
   @LegacyField(fieldId = 48, name = "_col-label-sa", format = "x(6)", initial = "?", label = "Col-label-SA", order = 48)
   private final character colLabelSa;

   /** Charset */
   @LegacyField(fieldId = 49, name = "_charset", format = "x(32)", initial = "?", label = "Charset", order = 49)
   private final character charset;

   /** Collation */
   @LegacyField(fieldId = 50, name = "_collation", format = "x(32)", initial = "?", label = "Collation", order = 50)
   private final character collation;

   /** Data member */
   @LegacyField(fieldId = 51, name = "_fetch-type", format = "x(10)", initial = "?", order = 51)
   private final character fetchType;

   /** Width */
   @LegacyField(fieldId = 52, name = "_width", format = ">>>>>>>>>9", initial = "?", label = "Width", order = 52)
   private final integer width;

   /** Data member */
   @LegacyField(fieldId = 53, name = "_field-physpos", format = ">>9", initial = "?", order = 53)
   private final integer fieldPhyspos;

   /** User-Misc */
   @LegacyField(fieldId = 54, name = "_user-misc", format = "x(10)", initial = "?", label = "User-Misc", order = 54)
   private final character userMisc;

   /** Data member */
   @LegacyField(fieldId = 55, name = "_attributes1", format = ">>9", initial = "0", order = 55)
   private final integer attributes1;

   /** Data member */
   @LegacyField(fieldId = 56, name = "_last-modified", format = "99/99/9999 HH:MM:SS.SSS+HH:MM", initial = "?", order = 56)
   private final datetimetz lastModified;

   /** Data member */
   @LegacyField(fieldId = 57, name = "_mod-sequence", format = ">>>>>>9", initial = "?", order = 57)
   private final integer modSequence;

   /** List of composite properties; 8 elements of type {@link MetaFieldImpl.Composite8 Composite8} */
   private List<Composite8> composite8 = new ArrayList<>(8);

   /**
    * Default constructor.
    */
   public MetaFieldImpl()
   {
      newName = new character("?");
      fileRecid = new recid();
      fieldName = new character("?");
      dataType = new character("?");
      dtype = new integer();
      initial = new character("?", true);
      label = new character("?", true);
      mandatory = new logical(false);
      format = new character("?");
      sysField = new logical(false);
      fieldRpos = new integer();
      decimals = new integer();
      order = new integer();
      canRead = new character("*");
      canWrite = new character("*");
      extent = new integer(0);
      valexp = new character("?");
      valmsg = new character("", true);
      help = new character("", true);
      desc = new character("", true);
      colLabel = new character("?", true);
      fldStdtype = new integer();
      fldStlen = new integer();
      fldStoff = new integer();
      fldCase = new logical(false);
      forId = new integer();
      forPrimary = new integer();
      forSpacing = new integer();
      forScale = new integer();
      forName = new character("?");
      forType = new character("?");
      forItype = new integer();
      forXpos = new integer();
      forRetrieve = new logical();
      forSeparator = new character("?");
      forMaxsize = new integer();
      forAllocated = new integer();
      viewAs = new character("?");
      initialSa = new character("?");
      labelSa = new character("?");
      formatSa = new character("?");
      valmsgSa = new character("");
      helpSa = new character("");
      colLabelSa = new character("?");
      charset = new character("?");
      collation = new character("?");
      fetchType = new character("?");
      width = new integer();
      fieldPhyspos = new integer();
      userMisc = new character("?");
      attributes1 = new integer(0);
      lastModified = new datetimetz();
      modSequence = new integer();
      
      // Populate Composite8 list.
      for (int i = 0; i < 8; i++)
      {
         composite8.add(new Composite8());
      }
   }

   /**
    * Make a deep copy of the current DMO instance and return it.
    * 
    * @return  A new instance of this class whose data is identical to that of this instance.
    */
   public Undoable deepCopy()
   {
      Undoable copy = new MetaFieldImpl();
      copy.assign(this);
      return copy;
   }

   /**
    * Modify the contained data of the instance to copy the instance data from the given, backup
    * instance.
    * 
    * @param   old
    *          The backup instance from which to copy data.
    */
   public void assign(Undoable old)
   {
      MetaFieldImpl from = (MetaFieldImpl) old;
      setId(from.id);
      setNewName(from.newName);
      setFileRecid(from.fileRecid);
      setFieldName(from.fieldName);
      setDataType(from.dataType);
      setDtype(from.dtype);
      setInitial(from.initial);
      setLabel(from.label);
      setMandatory(from.mandatory);
      setFormat(from.format);
      setSysField(from.sysField);
      setFieldRpos(from.fieldRpos);
      setDecimals(from.decimals);
      setOrder(from.order);
      setCanRead(from.canRead);
      setCanWrite(from.canWrite);
      setExtent(from.extent);
      setValexp(from.valexp);
      setValmsg(from.valmsg);
      setHelp(from.help);
      setDesc(from.desc);
      setColLabel(from.colLabel);
      setFldStdtype(from.fldStdtype);
      setFldStlen(from.fldStlen);
      setFldStoff(from.fldStoff);
      setFldCase(from.fldCase);
      setForId(from.forId);
      setForPrimary(from.forPrimary);
      setForSpacing(from.forSpacing);
      setForScale(from.forScale);
      setForName(from.forName);
      setForType(from.forType);
      setForItype(from.forItype);
      setForXpos(from.forXpos);
      setForRetrieve(from.forRetrieve);
      setForSeparator(from.forSeparator);
      setForMaxsize(from.forMaxsize);
      setForAllocated(from.forAllocated);
      setViewAs(from.viewAs);
      setInitialSa(from.initialSa);
      setLabelSa(from.labelSa);
      setFormatSa(from.formatSa);
      setValmsgSa(from.valmsgSa);
      setHelpSa(from.helpSa);
      setColLabelSa(from.colLabelSa);
      setCharset(from.charset);
      setCollation(from.collation);
      setFetchType(from.fetchType);
      setWidth(from.width);
      setFieldPhyspos(from.fieldPhyspos);
      setUserMisc(from.userMisc);
      setAttributes1(from.attributes1);
      setLastModified(from.lastModified);
      setModSequence(from.modSequence);
      
      // Assign Composite8 properties.
      for (int i = 0; i < 8; i++)
      {
         setFldMisc1(i, from.composite8.get(i).fldMisc1);
         setFldMisc2(i, from.composite8.get(i).fldMisc2);
         setFldRes1(i, from.composite8.get(i).fldRes1);
         setFldRes2(i, from.composite8.get(i).fldRes2);
      }
   }

   /**
    * Getter: Surrogate primary key
    * 
    * @return  Primary key
    */
   public Long getId()
   {
      return id;
   }

   /**
    * Setter: Surrogate primary key
    * 
    * @param   id
    *          Primary key
    */
   public void setId(Long id)
   {
      this.id = id;
   }

   /**
    * Getter: newName
    * 
    * @return  newName
    */
   public character getNewName()
   {
      return (new character(newName));
   }

   /**
    * Setter: newName
    * 
    * @param   newName
    *          newName
    */
   public void setNewName(Text newName)
   {
      this.newName.assign(newName);
   }

   /**
    * Getter: File-recid
    * 
    * @return  File-recid
    */
   public recid getFileRecid()
   {
      return (new recid(fileRecid));
   }

   /**
    * Setter: File-recid
    * 
    * @param   fileRecid
    *          File-recid
    */
   public void setFileRecid(NumberType fileRecid)
   {
      this.fileRecid.assign(fileRecid);
   }

   /**
    * Getter: Field-Name
    * 
    * @return  Field-Name
    */
   public character getFieldName()
   {
      return (new character(fieldName));
   }

   /**
    * Setter: Field-Name
    * 
    * @param   fieldName
    *          Field-Name
    */
   public void setFieldName(Text fieldName)
   {
      this.fieldName.assign(fieldName);
   }

   /**
    * Getter: Data-Type
    * 
    * @return  Data-Type
    */
   public character getDataType()
   {
      return (new character(dataType));
   }

   /**
    * Setter: Data-Type
    * 
    * @param   dataType
    *          Data-Type
    */
   public void setDataType(Text dataType)
   {
      this.dataType.assign(dataType);
   }

   /**
    * Getter: dtype
    * 
    * @return  dtype
    */
   public integer getDtype()
   {
      return (new integer(dtype));
   }

   /**
    * Setter: dtype
    * 
    * @param   dtype
    *          dtype
    */
   public void setDtype(NumberType dtype)
   {
      this.dtype.assign(dtype);
   }

   /**
    * Getter: Initial
    * 
    * @return  Initial
    */
   public character getInitial()
   {
      return (new character(initial));
   }

   /**
    * Setter: Initial
    * 
    * @param   initial
    *          Initial
    */
   public void setInitial(Text initial)
   {
      this.initial.assign(initial);
   }

   /**
    * Getter: Label
    * 
    * @return  Label
    */
   public character getLabel()
   {
      return (new character(label));
   }

   /**
    * Setter: Label
    * 
    * @param   label
    *          Label
    */
   public void setLabel(Text label)
   {
      this.label.assign(label);
   }

   /**
    * Getter: Mandatory
    * 
    * @return  Mandatory
    */
   public logical isMandatory()
   {
      return (new logical(mandatory));
   }

   /**
    * Setter: Mandatory
    * 
    * @param   mandatory
    *          Mandatory
    */
   public void setMandatory(logical mandatory)
   {
      this.mandatory.assign(mandatory);
   }

   /**
    * Getter: Format
    * 
    * @return  Format
    */
   public character getFormat()
   {
      return (new character(format));
   }

   /**
    * Setter: Format
    * 
    * @param   format
    *          Format
    */
   public void setFormat(Text format)
   {
      this.format.assign(format);
   }

   /**
    * Getter: sysField
    * 
    * @return  sysField
    */
   public logical isSysField()
   {
      return (new logical(sysField));
   }

   /**
    * Setter: sysField
    * 
    * @param   sysField
    *          sysField
    */
   public void setSysField(logical sysField)
   {
      this.sysField.assign(sysField);
   }

   /**
    * Getter: field-rpos
    * 
    * @return  field-rpos
    */
   public integer getFieldRpos()
   {
      return (new integer(fieldRpos));
   }

   /**
    * Setter: field-rpos
    * 
    * @param   fieldRpos
    *          field-rpos
    */
   public void setFieldRpos(NumberType fieldRpos)
   {
      this.fieldRpos.assign(fieldRpos);
   }

   /**
    * Getter: Decimals
    * 
    * @return  Decimals
    */
   public integer getDecimals()
   {
      return (new integer(decimals));
   }

   /**
    * Setter: Decimals
    * 
    * @param   decimals
    *          Decimals
    */
   public void setDecimals(NumberType decimals)
   {
      this.decimals.assign(decimals);
   }

   /**
    * Getter: Order
    * 
    * @return  Order
    */
   public integer getOrder()
   {
      return (new integer(order));
   }

   /**
    * Setter: Order
    * 
    * @param   order
    *          Order
    */
   public void setOrder(NumberType order)
   {
      this.order.assign(order);
   }

   /**
    * Getter: Can-Read
    * 
    * @return  Can-Read
    */
   public character getCanRead()
   {
      return (new character(canRead));
   }

   /**
    * Setter: Can-Read
    * 
    * @param   canRead
    *          Can-Read
    */
   public void setCanRead(Text canRead)
   {
      this.canRead.assign(canRead);
   }

   /**
    * Getter: Can-Write
    * 
    * @return  Can-Write
    */
   public character getCanWrite()
   {
      return (new character(canWrite));
   }

   /**
    * Setter: Can-Write
    * 
    * @param   canWrite
    *          Can-Write
    */
   public void setCanWrite(Text canWrite)
   {
      this.canWrite.assign(canWrite);
   }

   /**
    * Getter: Extent
    * 
    * @return  Extent
    */
   public integer getExtent()
   {
      return (new integer(extent));
   }

   /**
    * Setter: Extent
    * 
    * @param   extent
    *          Extent
    */
   public void setExtent(NumberType extent)
   {
      this.extent.assign(extent);
   }

   /**
    * Getter: Valexp
    * 
    * @return  Valexp
    */
   public character getValexp()
   {
      return (new character(valexp));
   }

   /**
    * Setter: Valexp
    * 
    * @param   valexp
    *          Valexp
    */
   public void setValexp(Text valexp)
   {
      this.valexp.assign(valexp);
   }

   /**
    * Getter: Valmsg
    * 
    * @return  Valmsg
    */
   public character getValmsg()
   {
      return (new character(valmsg));
   }

   /**
    * Setter: Valmsg
    * 
    * @param   valmsg
    *          Valmsg
    */
   public void setValmsg(Text valmsg)
   {
      this.valmsg.assign(valmsg);
   }

   /**
    * Getter: Help
    * 
    * @return  Help
    */
   public character getHelp()
   {
      return (new character(help));
   }

   /**
    * Setter: Help
    * 
    * @param   help
    *          Help
    */
   public void setHelp(Text help)
   {
      this.help.assign(help);
   }

   /**
    * Getter: Desc
    * 
    * @return  Desc
    */
   public character getDesc()
   {
      return (new character(desc));
   }

   /**
    * Setter: Desc
    * 
    * @param   desc
    *          Desc
    */
   public void setDesc(Text desc)
   {
      this.desc.assign(desc);
   }

   /**
    * Getter: Col-label
    * 
    * @return  Col-label
    */
   public character getColLabel()
   {
      return (new character(colLabel));
   }

   /**
    * Setter: Col-label
    * 
    * @param   colLabel
    *          Col-label
    */
   public void setColLabel(Text colLabel)
   {
      this.colLabel.assign(colLabel);
   }

   /**
    * Getter: fldStdtype
    * 
    * @return  fldStdtype
    */
   public integer getFldStdtype()
   {
      return (new integer(fldStdtype));
   }

   /**
    * Setter: fldStdtype
    * 
    * @param   fldStdtype
    *          fldStdtype
    */
   public void setFldStdtype(NumberType fldStdtype)
   {
      this.fldStdtype.assign(fldStdtype);
   }

   /**
    * Getter: fldStlen
    * 
    * @return  fldStlen
    */
   public integer getFldStlen()
   {
      return (new integer(fldStlen));
   }

   /**
    * Setter: fldStlen
    * 
    * @param   fldStlen
    *          fldStlen
    */
   public void setFldStlen(NumberType fldStlen)
   {
      this.fldStlen.assign(fldStlen);
   }

   /**
    * Getter: fldStoff
    * 
    * @return  fldStoff
    */
   public integer getFldStoff()
   {
      return (new integer(fldStoff));
   }

   /**
    * Setter: fldStoff
    * 
    * @param   fldStoff
    *          fldStoff
    */
   public void setFldStoff(NumberType fldStoff)
   {
      this.fldStoff.assign(fldStoff);
   }

   /**
    * Indexed Getter: fldMisc1
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * 
    * @return  fldMisc1
    */
   public integer getFldMisc1(int index)
   {
      return composite8.get(index).getFldMisc1();
   }

   /**
    * Indexed Setter: fldMisc1
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * @param   element
    *          fldMisc1
    */
   public void setFldMisc1(int index, NumberType element)
   {
      composite8.get(index).setFldMisc1(element);
   }

   /**
    * Indexed Getter: fldMisc2
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * 
    * @return  fldMisc2
    */
   public character getFldMisc2(int index)
   {
      return composite8.get(index).getFldMisc2();
   }

   /**
    * Indexed Setter: fldMisc2
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * @param   element
    *          fldMisc2
    */
   public void setFldMisc2(int index, Text element)
   {
      composite8.get(index).setFldMisc2(element);
   }

   /**
    * Getter: Fld-case
    * 
    * @return  Fld-case
    */
   public logical isFldCase()
   {
      return (new logical(fldCase));
   }

   /**
    * Setter: Fld-case
    * 
    * @param   fldCase
    *          Fld-case
    */
   public void setFldCase(logical fldCase)
   {
      this.fldCase.assign(fldCase);
   }

   /**
    * Indexed Getter: fldRes1
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * 
    * @return  fldRes1
    */
   public integer getFldRes1(int index)
   {
      return composite8.get(index).getFldRes1();
   }

   /**
    * Indexed Setter: fldRes1
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * @param   element
    *          fldRes1
    */
   public void setFldRes1(int index, NumberType element)
   {
      composite8.get(index).setFldRes1(element);
   }

   /**
    * Indexed Getter: fldRes2
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * 
    * @return  fldRes2
    */
   public character getFldRes2(int index)
   {
      return composite8.get(index).getFldRes2();
   }

   /**
    * Indexed Setter: fldRes2
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * @param   element
    *          fldRes2
    */
   public void setFldRes2(int index, Text element)
   {
      composite8.get(index).setFldRes2(element);
   }

   /**
    * Getter: forId
    * 
    * @return  forId
    */
   public integer getForId()
   {
      return (new integer(forId));
   }

   /**
    * Setter: forId
    * 
    * @param   forId
    *          forId
    */
   public void setForId(NumberType forId)
   {
      this.forId.assign(forId);
   }

   /**
    * Getter: forPrimary
    * 
    * @return  forPrimary
    */
   public integer getForPrimary()
   {
      return (new integer(forPrimary));
   }

   /**
    * Setter: forPrimary
    * 
    * @param   forPrimary
    *          forPrimary
    */
   public void setForPrimary(NumberType forPrimary)
   {
      this.forPrimary.assign(forPrimary);
   }

   /**
    * Getter: forSpacing
    * 
    * @return  forSpacing
    */
   public integer getForSpacing()
   {
      return (new integer(forSpacing));
   }

   /**
    * Setter: forSpacing
    * 
    * @param   forSpacing
    *          forSpacing
    */
   public void setForSpacing(NumberType forSpacing)
   {
      this.forSpacing.assign(forSpacing);
   }

   /**
    * Getter: forScale
    * 
    * @return  forScale
    */
   public integer getForScale()
   {
      return (new integer(forScale));
   }

   /**
    * Setter: forScale
    * 
    * @param   forScale
    *          forScale
    */
   public void setForScale(NumberType forScale)
   {
      this.forScale.assign(forScale);
   }

   /**
    * Getter: forName
    * 
    * @return  forName
    */
   public character getForName()
   {
      return (new character(forName));
   }

   /**
    * Setter: forName
    * 
    * @param   forName
    *          forName
    */
   public void setForName(Text forName)
   {
      this.forName.assign(forName);
   }

   /**
    * Getter: forType
    * 
    * @return  forType
    */
   public character getForType()
   {
      return (new character(forType));
   }

   /**
    * Setter: forType
    * 
    * @param   forType
    *          forType
    */
   public void setForType(Text forType)
   {
      this.forType.assign(forType);
   }

   /**
    * Getter: forItype
    * 
    * @return  forItype
    */
   public integer getForItype()
   {
      return (new integer(forItype));
   }

   /**
    * Setter: forItype
    * 
    * @param   forItype
    *          forItype
    */
   public void setForItype(NumberType forItype)
   {
      this.forItype.assign(forItype);
   }

   /**
    * Getter: forXpos
    * 
    * @return  forXpos
    */
   public integer getForXpos()
   {
      return (new integer(forXpos));
   }

   /**
    * Setter: forXpos
    * 
    * @param   forXpos
    *          forXpos
    */
   public void setForXpos(NumberType forXpos)
   {
      this.forXpos.assign(forXpos);
   }

   /**
    * Getter: forRetrieve
    * 
    * @return  forRetrieve
    */
   public logical isForRetrieve()
   {
      return (new logical(forRetrieve));
   }

   /**
    * Setter: forRetrieve
    * 
    * @param   forRetrieve
    *          forRetrieve
    */
   public void setForRetrieve(logical forRetrieve)
   {
      this.forRetrieve.assign(forRetrieve);
   }

   /**
    * Getter: forSeparator
    * 
    * @return  forSeparator
    */
   public character getForSeparator()
   {
      return (new character(forSeparator));
   }

   /**
    * Setter: forSeparator
    * 
    * @param   forSeparator
    *          forSeparator
    */
   public void setForSeparator(Text forSeparator)
   {
      this.forSeparator.assign(forSeparator);
   }

   /**
    * Getter: forMaxsize
    * 
    * @return  forMaxsize
    */
   public integer getForMaxsize()
   {
      return (new integer(forMaxsize));
   }

   /**
    * Setter: forMaxsize
    * 
    * @param   forMaxsize
    *          forMaxsize
    */
   public void setForMaxsize(NumberType forMaxsize)
   {
      this.forMaxsize.assign(forMaxsize);
   }

   /**
    * Getter: forAllocated
    * 
    * @return  forAllocated
    */
   public integer getForAllocated()
   {
      return (new integer(forAllocated));
   }

   /**
    * Setter: forAllocated
    * 
    * @param   forAllocated
    *          forAllocated
    */
   public void setForAllocated(NumberType forAllocated)
   {
      this.forAllocated.assign(forAllocated);
   }

   /**
    * Getter: View-As
    * 
    * @return  View-As
    */
   public character getViewAs()
   {
      return (new character(viewAs));
   }

   /**
    * Setter: View-As
    * 
    * @param   viewAs
    *          View-As
    */
   public void setViewAs(Text viewAs)
   {
      this.viewAs.assign(viewAs);
   }

   /**
    * Getter: Initial-SA
    * 
    * @return  Initial-SA
    */
   public character getInitialSa()
   {
      return (new character(initialSa));
   }

   /**
    * Setter: Initial-SA
    * 
    * @param   initialSa
    *          Initial-SA
    */
   public void setInitialSa(Text initialSa)
   {
      this.initialSa.assign(initialSa);
   }

   /**
    * Getter: Label-SA
    * 
    * @return  Label-SA
    */
   public character getLabelSa()
   {
      return (new character(labelSa));
   }

   /**
    * Setter: Label-SA
    * 
    * @param   labelSa
    *          Label-SA
    */
   public void setLabelSa(Text labelSa)
   {
      this.labelSa.assign(labelSa);
   }

   /**
    * Getter: Format-SA
    * 
    * @return  Format-SA
    */
   public character getFormatSa()
   {
      return (new character(formatSa));
   }

   /**
    * Setter: Format-SA
    * 
    * @param   formatSa
    *          Format-SA
    */
   public void setFormatSa(Text formatSa)
   {
      this.formatSa.assign(formatSa);
   }

   /**
    * Getter: Valmsg-SA
    * 
    * @return  Valmsg-SA
    */
   public character getValmsgSa()
   {
      return (new character(valmsgSa));
   }

   /**
    * Setter: Valmsg-SA
    * 
    * @param   valmsgSa
    *          Valmsg-SA
    */
   public void setValmsgSa(Text valmsgSa)
   {
      this.valmsgSa.assign(valmsgSa);
   }

   /**
    * Getter: Help-SA
    * 
    * @return  Help-SA
    */
   public character getHelpSa()
   {
      return (new character(helpSa));
   }

   /**
    * Setter: Help-SA
    * 
    * @param   helpSa
    *          Help-SA
    */
   public void setHelpSa(Text helpSa)
   {
      this.helpSa.assign(helpSa);
   }

   /**
    * Getter: Col-label-SA
    * 
    * @return  Col-label-SA
    */
   public character getColLabelSa()
   {
      return (new character(colLabelSa));
   }

   /**
    * Setter: Col-label-SA
    * 
    * @param   colLabelSa
    *          Col-label-SA
    */
   public void setColLabelSa(Text colLabelSa)
   {
      this.colLabelSa.assign(colLabelSa);
   }

   /**
    * Getter: Charset
    * 
    * @return  Charset
    */
   public character getCharset()
   {
      return (new character(charset));
   }

   /**
    * Setter: Charset
    * 
    * @param   charset
    *          Charset
    */
   public void setCharset(Text charset)
   {
      this.charset.assign(charset);
   }

   /**
    * Getter: Collation
    * 
    * @return  Collation
    */
   public character getCollation()
   {
      return (new character(collation));
   }

   /**
    * Setter: Collation
    * 
    * @param   collation
    *          Collation
    */
   public void setCollation(Text collation)
   {
      this.collation.assign(collation);
   }

   /**
    * Getter: fetchType
    * 
    * @return  fetchType
    */
   public character getFetchType()
   {
      return (new character(fetchType));
   }

   /**
    * Setter: fetchType
    * 
    * @param   fetchType
    *          fetchType
    */
   public void setFetchType(Text fetchType)
   {
      this.fetchType.assign(fetchType);
   }

   /**
    * Getter: Width
    * 
    * @return  Width
    */
   public integer getWidth()
   {
      return (new integer(width));
   }

   /**
    * Setter: Width
    * 
    * @param   width
    *          Width
    */
   public void setWidth(NumberType width)
   {
      this.width.assign(width);
   }

   /**
    * Getter: fieldPhyspos
    * 
    * @return  fieldPhyspos
    */
   public integer getFieldPhyspos()
   {
      return (new integer(fieldPhyspos));
   }

   /**
    * Setter: fieldPhyspos
    * 
    * @param   fieldPhyspos
    *          fieldPhyspos
    */
   public void setFieldPhyspos(NumberType fieldPhyspos)
   {
      this.fieldPhyspos.assign(fieldPhyspos);
   }

   /**
    * Getter: User-Misc
    * 
    * @return  User-Misc
    */
   public character getUserMisc()
   {
      return (new character(userMisc));
   }

   /**
    * Setter: User-Misc
    * 
    * @param   userMisc
    *          User-Misc
    */
   public void setUserMisc(Text userMisc)
   {
      this.userMisc.assign(userMisc);
   }

   /**
    * Getter: attributes1
    * 
    * @return  attributes1
    */
   public integer getAttributes1()
   {
      return (new integer(attributes1));
   }

   /**
    * Setter: attributes1
    * 
    * @param   attributes1
    *          attributes1
    */
   public void setAttributes1(NumberType attributes1)
   {
      this.attributes1.assign(attributes1);
   }

   /**
    * Getter: lastModified
    * 
    * @return  lastModified
    */
   public datetimetz getLastModified()
   {
      return (new datetimetz(lastModified));
   }

   /**
    * Setter: lastModified
    * 
    * @param   lastModified
    *          lastModified
    */
   public void setLastModified(date lastModified)
   {
      this.lastModified.assign(lastModified);
   }

   /**
    * Getter: modSequence
    * 
    * @return  modSequence
    */
   public integer getModSequence()
   {
      return (new integer(modSequence));
   }

   /**
    * Setter: modSequence
    * 
    * @param   modSequence
    *          modSequence
    */
   public void setModSequence(NumberType modSequence)
   {
      this.modSequence.assign(modSequence);
   }

   /**
    * Inner class which composites properties of like extent. All properties migrated from the
    * legacy table <code>_meta._field</code> of extent 8 are data members of this class.
    */
   static class Composite8
   implements Serializable
   {
      /** Data member */
      @LegacyField(fieldId = 25, name = "_fld-misc1", format = ">>>9", initial = "?", order = 25, extent = 8)
      private final integer fldMisc1;

      /** Data member */
      @LegacyField(fieldId = 26, name = "_fld-misc2", format = "x(12)", initial = "?", order = 26, extent = 8)
      private final character fldMisc2;

      /** Data member */
      @LegacyField(fieldId = 28, name = "_fld-res1", format = ">>>9", initial = "?", order = 28, extent = 8)
      private final integer fldRes1;

      /** Data member */
      @LegacyField(fieldId = 29, name = "_fld-res2", format = "x(12)", initial = "?", order = 29, extent = 8)
      private final character fldRes2;

      /**
       * Default constructor.
       */
      public Composite8()
      {
         fldMisc1 = new integer();
         fldMisc2 = new character("?");
         fldRes1 = new integer();
         fldRes2 = new character("?");
      }

      /**
       * Getter: fldMisc1
       * 
       * @return  fldMisc1
       */
      public integer getFldMisc1()
      {
         return (new integer(fldMisc1));
      }

      /**
       * Setter: fldMisc1
       * 
       * @param   fldMisc1
       *          fldMisc1
       */
      public void setFldMisc1(NumberType fldMisc1)
      {
         this.fldMisc1.assign(fldMisc1);
      }

      /**
       * Getter: fldMisc2
       * 
       * @return  fldMisc2
       */
      public character getFldMisc2()
      {
         return (new character(fldMisc2));
      }

      /**
       * Setter: fldMisc2
       * 
       * @param   fldMisc2
       *          fldMisc2
       */
      public void setFldMisc2(Text fldMisc2)
      {
         this.fldMisc2.assign(fldMisc2);
      }

      /**
       * Getter: fldRes1
       * 
       * @return  fldRes1
       */
      public integer getFldRes1()
      {
         return (new integer(fldRes1));
      }

      /**
       * Setter: fldRes1
       * 
       * @param   fldRes1
       *          fldRes1
       */
      public void setFldRes1(NumberType fldRes1)
      {
         this.fldRes1.assign(fldRes1);
      }

      /**
       * Getter: fldRes2
       * 
       * @return  fldRes2
       */
      public character getFldRes2()
      {
         return (new character(fldRes2));
      }

      /**
       * Setter: fldRes2
       * 
       * @param   fldRes2
       *          fldRes2
       */
      public void setFldRes2(Text fldRes2)
      {
         this.fldRes2.assign(fldRes2);
      }
   }
}
