package com.goldencode.hotel.dmo._meta.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;
import com.goldencode.hotel.dmo._meta.*;

/**
 * Data Model Object corresponding with table <code>_meta.meta_file</code> (previously
 * <code>_meta._file</code>).
 */
@LegacyTable(name = "_file", table = "meta_file")
@LegacyIndexes(
{
   @LegacyIndex(name = "_file-name", converted = "meta_file_file_name", primary = true, components = 
   {
      @LegacyIndexComponent(fieldName = "_file-name")
   }),
   @LegacyIndex(name = "_db/file", converted = "meta_file_db_file", unique = true, components = 
   {
      @LegacyIndexComponent(fieldName = "_db-recid"),
      @LegacyIndexComponent(fieldName = "_file-name"),
      @LegacyIndexComponent(fieldName = "_owner")
   }),
   @LegacyIndex(name = "_dump-name", converted = "meta_file_dump_name", unique = true, components = 
   {
      @LegacyIndexComponent(fieldName = "_db-recid"),
      @LegacyIndexComponent(fieldName = "_dump-name"),
      @LegacyIndexComponent(fieldName = "_owner")
   }),
   @LegacyIndex(name = "_file-number", converted = "meta_file_file_number", components = 
   {
      @LegacyIndexComponent(fieldName = "_file-number")
   })
})
public class MetaFileImpl
implements Serializable,
           Persistable,
           MetaFile
{
   /** Surrogate primary key */
   private Long id = null;

   /** Data member */
   @LegacyField(fieldId = 1, name = "_new-name", format = "x(32)", initial = "?", mandatory = true, order = -1)
   private final character newName;

   /** File-Name */
   @LegacyField(fieldId = 2, name = "_file-name", format = "x(32)", initial = "?", label = "File-Name", mandatory = true, order = 2)
   private final character fileName;

   /** Prime-Index */
   @LegacyField(fieldId = 3, name = "_prime-index", format = ">>>>>>>9", initial = "?", label = "Prime-Index", order = 3)
   private final recid primeIndex;

   /** File-Number */
   @LegacyField(fieldId = 4, name = "_file-number", format = "->>>>9", initial = "?", label = "File-Number", order = 4)
   private final integer fileNumber;

   /** Data member */
   @LegacyField(fieldId = 5, name = "_dft-pk", format = "yes/no", initial = "false", order = 5)
   private final logical dftPk;

   /** Data member */
   @LegacyField(fieldId = 6, name = "_numkey", format = ">>9", initial = "0", order = 6)
   private final integer numkey;

   /** Data member */
   @LegacyField(fieldId = 7, name = "_numkfld", format = ">>9", initial = "0", order = 7)
   private final integer numkfld;

   /** Data member */
   @LegacyField(fieldId = 8, name = "_numkcomp", format = ">>9", initial = "0", order = 8)
   private final integer numkcomp;

   /** Data member */
   @LegacyField(fieldId = 9, name = "_template", format = ">>>>>>>9", initial = "?", order = 9)
   private final recid template;

   /** Data member */
   @LegacyField(fieldId = 10, name = "_numfld", format = ">>9", initial = "1", order = 10)
   private final integer numfld;

   /** Can-Create */
   @LegacyField(fieldId = 11, name = "_can-create", format = "x(63)", initial = "*", label = "Can-Create", mandatory = true, order = 11)
   private final character canCreate;

   /** Can-Read */
   @LegacyField(fieldId = 12, name = "_can-read", format = "x(63)", initial = "*", label = "Can-Read", mandatory = true, order = 12)
   private final character canRead;

   /** Can-Write */
   @LegacyField(fieldId = 13, name = "_can-write", format = "x(63)", initial = "*", label = "Can-Write", mandatory = true, order = 13)
   private final character canWrite;

   /** Can-Delete */
   @LegacyField(fieldId = 14, name = "_can-delete", format = "x(63)", initial = "*", label = "Can-Delete", mandatory = true, order = 14)
   private final character canDelete;

   /** Desc */
   @LegacyField(fieldId = 15, name = "_desc", format = "x(72)", label = "Desc", order = 15, caseSensitive = true)
   private final character desc;

   /** Db-recid */
   @LegacyField(fieldId = 16, name = "_db-recid", format = ">>>>>>>9", initial = "?", label = "Db-recid", mandatory = true, order = 16)
   private final recid dbRecid;

   /** Valexp */
   @LegacyField(fieldId = 17, name = "_valexp", format = "x(72)", initial = "?", label = "Valexp", order = 17)
   private final character valexp;

   /** Valmsg */
   @LegacyField(fieldId = 18, name = "_valmsg", format = "x(72)", label = "Valmsg", order = 18, caseSensitive = true)
   private final character valmsg;

   /** Data member */
   @LegacyField(fieldId = 21, name = "_last-change", format = "->>>>>>>>>9", initial = "?", order = 21)
   private final integer lastChange;

   /** Data member */
   @LegacyField(fieldId = 22, name = "_db-lang", format = ">>9", initial = "0", order = 22)
   private final integer dbLang;

   /** Data member */
   @LegacyField(fieldId = 23, name = "_hidden", format = "yes/no", initial = "false", order = 23)
   private final logical hidden;

   /** Frozen */
   @LegacyField(fieldId = 24, name = "_frozen", format = "yes/no", initial = "false", label = "Frozen", order = 24)
   private final logical frozen;

   /** Dump-name */
   @LegacyField(fieldId = 25, name = "_dump-name", format = "x(8)", initial = "?", label = "Dump-name", order = 25, caseSensitive = true)
   private final character dumpName;

   /** CRC */
   @LegacyField(fieldId = 26, name = "_crc", format = ">>>>>9", initial = "?", label = "CRC", order = 26)
   private final integer crc;

   /** Data member */
   @LegacyField(fieldId = 29, name = "_cache", format = "x(8)", mandatory = true, order = 29)
   private final raw cache;

   /** Data member */
   @LegacyField(fieldId = 30, name = "_for-size", format = ">>>>9", initial = "?", order = 30)
   private final integer forSize;

   /** Data member */
   @LegacyField(fieldId = 31, name = "_for-flag", format = "->,>>>,>>>,>>9", initial = "?", order = 31)
   private final integer forFlag;

   /** Data member */
   @LegacyField(fieldId = 32, name = "_for-cnt1", format = ">>>9", initial = "?", order = 32)
   private final integer forCnt1;

   /** Data member */
   @LegacyField(fieldId = 33, name = "_for-cnt2", format = ">>>9", initial = "?", order = 33)
   private final integer forCnt2;

   /** Data member */
   @LegacyField(fieldId = 34, name = "_for-name", format = "x(32)", initial = "?", order = 34, caseSensitive = true)
   private final character forName;

   /** Data member */
   @LegacyField(fieldId = 35, name = "_for-owner", format = "x(32)", initial = "?", order = 35, caseSensitive = true)
   private final character forOwner;

   /** Data member */
   @LegacyField(fieldId = 36, name = "_for-format", format = "x(12)", initial = "?", order = 36)
   private final character forFormat;

   /** Data member */
   @LegacyField(fieldId = 37, name = "_for-info", format = "x(12)", initial = "?", order = 37)
   private final character forInfo;

   /** Data member */
   @LegacyField(fieldId = 38, name = "_for-type", format = "x(20)", initial = "?", order = 38)
   private final character forType;

   /** Data member */
   @LegacyField(fieldId = 39, name = "_for-id", format = ">>>>9", initial = "?", order = 39)
   private final integer forId;

   /** Data member */
   @LegacyField(fieldId = 40, name = "_for-number", format = ">>>>9", initial = "?", order = 40)
   private final integer forNumber;

   /** File-Label */
   @LegacyField(fieldId = 41, name = "_file-label", format = "x(30)", initial = "?", label = "File-Label", order = 41)
   private final character fileLabel;

   /** Can-Dump */
   @LegacyField(fieldId = 42, name = "_can-dump", format = "x(63)", initial = "*", label = "Can-Dump", mandatory = true, order = 42)
   private final character canDump;

   /** Can-Load */
   @LegacyField(fieldId = 43, name = "_can-load", format = "x(63)", initial = "*", label = "Can-Load", mandatory = true, order = 43)
   private final character canLoad;

   /** Valmsg-SA */
   @LegacyField(fieldId = 44, name = "_valmsg-sa", format = "x(6)", initial = "?", label = "Valmsg-SA", order = 44)
   private final character valmsgSa;

   /** File-Label-SA */
   @LegacyField(fieldId = 45, name = "_file-label-sa", format = "x(6)", initial = "?", label = "File-Label-SA", order = 45)
   private final character fileLabelSa;

   /** ianum */
   @LegacyField(fieldId = 46, name = "_ianum", format = ">>>>9", initial = "?", label = "ianum", order = 46)
   private final integer ianum;

   /** Data member */
   @LegacyField(fieldId = 47, name = "_version", format = ">>9", initial = "0", order = 47)
   private final integer version;

   /** Data member */
   @LegacyField(fieldId = 48, name = "_field-map", format = "x(8)", initial = "?", order = 48)
   private final raw fieldMap;

   /** Creator */
   @LegacyField(fieldId = 49, name = "_creator", format = "x(32)", initial = "PUB", label = "Creator", mandatory = true, order = 49)
   private final character creator;

   /** Data member */
   @LegacyField(fieldId = 50, name = "_has-ccnstrs", format = "x(1)", initial = "N", mandatory = true, order = 50)
   private final character hasCcnstrs;

   /** Data member */
   @LegacyField(fieldId = 51, name = "_has-fcnstrs", format = "x(1)", initial = "N", mandatory = true, order = 51)
   private final character hasFcnstrs;

   /** Data member */
   @LegacyField(fieldId = 52, name = "_has-pcnstrs", format = "x(1)", initial = "N", mandatory = true, order = 52)
   private final character hasPcnstrs;

   /** Data member */
   @LegacyField(fieldId = 53, name = "_has-ucnstrs", format = "x(1)", initial = "N", mandatory = true, order = 53)
   private final character hasUcnstrs;

   /** Owner */
   @LegacyField(fieldId = 54, name = "_owner", format = "x(32)", initial = "PUB", label = "Owner", mandatory = true, order = 54)
   private final character owner;

   /** Data member */
   @LegacyField(fieldId = 55, name = "_rssid", format = ">>9", initial = "5", mandatory = true, order = 55)
   private final integer rssid;

   /** Data member */
   @LegacyField(fieldId = 56, name = "_tbl-status", format = "x(1)", initial = "Y", mandatory = true, order = 56)
   private final character tblStatus;

   /** Tbl-Type */
   @LegacyField(fieldId = 57, name = "_tbl-type", format = "x(1)", initial = "T", label = "Tbl-Type", mandatory = true, order = 57)
   private final character tblType;

   /** User-Misc */
   @LegacyField(fieldId = 58, name = "_user-misc", format = "x(10)", initial = "?", label = "User-Misc", order = 58)
   private final character userMisc;

   /** Data member */
   @LegacyField(fieldId = 59, name = "_last-modified", format = "99/99/9999 HH:MM:SS.SSS+HH:MM", initial = "?", order = 59)
   private final datetimetz lastModified;

   /** Data member */
   @LegacyField(fieldId = 60, name = "_mod-sequence", format = ">>>>>>9", initial = "?", order = 60)
   private final integer modSequence;

   /** List of composite properties; 8 elements of type {@link MetaFileImpl.Composite8 Composite8} */
   private List<Composite8> composite8 = new ArrayList<>(8);

   /**
    * Default constructor.
    */
   public MetaFileImpl()
   {
      newName = new character("?");
      fileName = new character("?");
      primeIndex = new recid();
      fileNumber = new integer();
      dftPk = new logical(false);
      numkey = new integer(0);
      numkfld = new integer(0);
      numkcomp = new integer(0);
      template = new recid();
      numfld = new integer(1);
      canCreate = new character("*");
      canRead = new character("*");
      canWrite = new character("*");
      canDelete = new character("*");
      desc = new character("", true);
      dbRecid = new recid();
      valexp = new character("?");
      valmsg = new character("", true);
      lastChange = new integer();
      dbLang = new integer(0);
      hidden = new logical(false);
      frozen = new logical(false);
      dumpName = new character("?", true);
      crc = new integer();
      cache = new raw();
      forSize = new integer();
      forFlag = new integer();
      forCnt1 = new integer();
      forCnt2 = new integer();
      forName = new character("?", true);
      forOwner = new character("?", true);
      forFormat = new character("?");
      forInfo = new character("?");
      forType = new character("?");
      forId = new integer();
      forNumber = new integer();
      fileLabel = new character("?");
      canDump = new character("*");
      canLoad = new character("*");
      valmsgSa = new character("?");
      fileLabelSa = new character("?");
      ianum = new integer();
      version = new integer(0);
      fieldMap = new raw();
      creator = new character("PUB");
      hasCcnstrs = new character("N");
      hasFcnstrs = new character("N");
      hasPcnstrs = new character("N");
      hasUcnstrs = new character("N");
      owner = new character("PUB");
      rssid = new integer(5);
      tblStatus = new character("Y");
      tblType = new character("T");
      userMisc = new character("?");
      lastModified = new datetimetz();
      modSequence = new integer();
      
      // Populate Composite8 list.
      for (int i = 0; i < 8; i++)
      {
         composite8.add(new Composite8());
      }
   }

   /**
    * Make a deep copy of the current DMO instance and return it.
    * 
    * @return  A new instance of this class whose data is identical to that of this instance.
    */
   public Undoable deepCopy()
   {
      Undoable copy = new MetaFileImpl();
      copy.assign(this);
      return copy;
   }

   /**
    * Modify the contained data of the instance to copy the instance data from the given, backup
    * instance.
    * 
    * @param   old
    *          The backup instance from which to copy data.
    */
   public void assign(Undoable old)
   {
      MetaFileImpl from = (MetaFileImpl) old;
      setId(from.id);
      setNewName(from.newName);
      setFileName(from.fileName);
      setPrimeIndex(from.primeIndex);
      setFileNumber(from.fileNumber);
      setDftPk(from.dftPk);
      setNumkey(from.numkey);
      setNumkfld(from.numkfld);
      setNumkcomp(from.numkcomp);
      setTemplate(from.template);
      setNumfld(from.numfld);
      setCanCreate(from.canCreate);
      setCanRead(from.canRead);
      setCanWrite(from.canWrite);
      setCanDelete(from.canDelete);
      setDesc(from.desc);
      setDbRecid(from.dbRecid);
      setValexp(from.valexp);
      setValmsg(from.valmsg);
      setLastChange(from.lastChange);
      setDbLang(from.dbLang);
      setHidden(from.hidden);
      setFrozen(from.frozen);
      setDumpName(from.dumpName);
      setCrc(from.crc);
      setCache(from.cache);
      setForSize(from.forSize);
      setForFlag(from.forFlag);
      setForCnt1(from.forCnt1);
      setForCnt2(from.forCnt2);
      setForName(from.forName);
      setForOwner(from.forOwner);
      setForFormat(from.forFormat);
      setForInfo(from.forInfo);
      setForType(from.forType);
      setForId(from.forId);
      setForNumber(from.forNumber);
      setFileLabel(from.fileLabel);
      setCanDump(from.canDump);
      setCanLoad(from.canLoad);
      setValmsgSa(from.valmsgSa);
      setFileLabelSa(from.fileLabelSa);
      setIanum(from.ianum);
      setVersion(from.version);
      setFieldMap(from.fieldMap);
      setCreator(from.creator);
      setHasCcnstrs(from.hasCcnstrs);
      setHasFcnstrs(from.hasFcnstrs);
      setHasPcnstrs(from.hasPcnstrs);
      setHasUcnstrs(from.hasUcnstrs);
      setOwner(from.owner);
      setRssid(from.rssid);
      setTblStatus(from.tblStatus);
      setTblType(from.tblType);
      setUserMisc(from.userMisc);
      setLastModified(from.lastModified);
      setModSequence(from.modSequence);
      
      // Assign Composite8 properties.
      for (int i = 0; i < 8; i++)
      {
         setFilMisc1(i, from.composite8.get(i).filMisc1);
         setFilMisc2(i, from.composite8.get(i).filMisc2);
         setFilRes1(i, from.composite8.get(i).filRes1);
         setFilRes2(i, from.composite8.get(i).filRes2);
      }
   }

   /**
    * Getter: Surrogate primary key
    * 
    * @return  Primary key
    */
   public Long getId()
   {
      return id;
   }

   /**
    * Setter: Surrogate primary key
    * 
    * @param   id
    *          Primary key
    */
   public void setId(Long id)
   {
      this.id = id;
   }

   /**
    * Getter: newName
    * 
    * @return  newName
    */
   public character getNewName()
   {
      return (new character(newName));
   }

   /**
    * Setter: newName
    * 
    * @param   newName
    *          newName
    */
   public void setNewName(Text newName)
   {
      this.newName.assign(newName);
   }

   /**
    * Getter: File-Name
    * 
    * @return  File-Name
    */
   public character getFileName()
   {
      return (new character(fileName));
   }

   /**
    * Setter: File-Name
    * 
    * @param   fileName
    *          File-Name
    */
   public void setFileName(Text fileName)
   {
      this.fileName.assign(fileName);
   }

   /**
    * Getter: Prime-Index
    * 
    * @return  Prime-Index
    */
   public recid getPrimeIndex()
   {
      return (new recid(primeIndex));
   }

   /**
    * Setter: Prime-Index
    * 
    * @param   primeIndex
    *          Prime-Index
    */
   public void setPrimeIndex(NumberType primeIndex)
   {
      this.primeIndex.assign(primeIndex);
   }

   /**
    * Getter: File-Number
    * 
    * @return  File-Number
    */
   public integer getFileNumber()
   {
      return (new integer(fileNumber));
   }

   /**
    * Setter: File-Number
    * 
    * @param   fileNumber
    *          File-Number
    */
   public void setFileNumber(NumberType fileNumber)
   {
      this.fileNumber.assign(fileNumber);
   }

   /**
    * Getter: dftPk
    * 
    * @return  dftPk
    */
   public logical isDftPk()
   {
      return (new logical(dftPk));
   }

   /**
    * Setter: dftPk
    * 
    * @param   dftPk
    *          dftPk
    */
   public void setDftPk(logical dftPk)
   {
      this.dftPk.assign(dftPk);
   }

   /**
    * Getter: numkey
    * 
    * @return  numkey
    */
   public integer getNumkey()
   {
      return (new integer(numkey));
   }

   /**
    * Setter: numkey
    * 
    * @param   numkey
    *          numkey
    */
   public void setNumkey(NumberType numkey)
   {
      this.numkey.assign(numkey);
   }

   /**
    * Getter: numkfld
    * 
    * @return  numkfld
    */
   public integer getNumkfld()
   {
      return (new integer(numkfld));
   }

   /**
    * Setter: numkfld
    * 
    * @param   numkfld
    *          numkfld
    */
   public void setNumkfld(NumberType numkfld)
   {
      this.numkfld.assign(numkfld);
   }

   /**
    * Getter: numkcomp
    * 
    * @return  numkcomp
    */
   public integer getNumkcomp()
   {
      return (new integer(numkcomp));
   }

   /**
    * Setter: numkcomp
    * 
    * @param   numkcomp
    *          numkcomp
    */
   public void setNumkcomp(NumberType numkcomp)
   {
      this.numkcomp.assign(numkcomp);
   }

   /**
    * Getter: template
    * 
    * @return  template
    */
   public recid getTemplate()
   {
      return (new recid(template));
   }

   /**
    * Setter: template
    * 
    * @param   template
    *          template
    */
   public void setTemplate(NumberType template)
   {
      this.template.assign(template);
   }

   /**
    * Getter: numfld
    * 
    * @return  numfld
    */
   public integer getNumfld()
   {
      return (new integer(numfld));
   }

   /**
    * Setter: numfld
    * 
    * @param   numfld
    *          numfld
    */
   public void setNumfld(NumberType numfld)
   {
      this.numfld.assign(numfld);
   }

   /**
    * Getter: Can-Create
    * 
    * @return  Can-Create
    */
   public character getCanCreate()
   {
      return (new character(canCreate));
   }

   /**
    * Setter: Can-Create
    * 
    * @param   canCreate
    *          Can-Create
    */
   public void setCanCreate(Text canCreate)
   {
      this.canCreate.assign(canCreate);
   }

   /**
    * Getter: Can-Read
    * 
    * @return  Can-Read
    */
   public character getCanRead()
   {
      return (new character(canRead));
   }

   /**
    * Setter: Can-Read
    * 
    * @param   canRead
    *          Can-Read
    */
   public void setCanRead(Text canRead)
   {
      this.canRead.assign(canRead);
   }

   /**
    * Getter: Can-Write
    * 
    * @return  Can-Write
    */
   public character getCanWrite()
   {
      return (new character(canWrite));
   }

   /**
    * Setter: Can-Write
    * 
    * @param   canWrite
    *          Can-Write
    */
   public void setCanWrite(Text canWrite)
   {
      this.canWrite.assign(canWrite);
   }

   /**
    * Getter: Can-Delete
    * 
    * @return  Can-Delete
    */
   public character getCanDelete()
   {
      return (new character(canDelete));
   }

   /**
    * Setter: Can-Delete
    * 
    * @param   canDelete
    *          Can-Delete
    */
   public void setCanDelete(Text canDelete)
   {
      this.canDelete.assign(canDelete);
   }

   /**
    * Getter: Desc
    * 
    * @return  Desc
    */
   public character getDesc()
   {
      return (new character(desc));
   }

   /**
    * Setter: Desc
    * 
    * @param   desc
    *          Desc
    */
   public void setDesc(Text desc)
   {
      this.desc.assign(desc);
   }

   /**
    * Getter: Db-recid
    * 
    * @return  Db-recid
    */
   public recid getDbRecid()
   {
      return (new recid(dbRecid));
   }

   /**
    * Setter: Db-recid
    * 
    * @param   dbRecid
    *          Db-recid
    */
   public void setDbRecid(NumberType dbRecid)
   {
      this.dbRecid.assign(dbRecid);
   }

   /**
    * Getter: Valexp
    * 
    * @return  Valexp
    */
   public character getValexp()
   {
      return (new character(valexp));
   }

   /**
    * Setter: Valexp
    * 
    * @param   valexp
    *          Valexp
    */
   public void setValexp(Text valexp)
   {
      this.valexp.assign(valexp);
   }

   /**
    * Getter: Valmsg
    * 
    * @return  Valmsg
    */
   public character getValmsg()
   {
      return (new character(valmsg));
   }

   /**
    * Setter: Valmsg
    * 
    * @param   valmsg
    *          Valmsg
    */
   public void setValmsg(Text valmsg)
   {
      this.valmsg.assign(valmsg);
   }

   /**
    * Indexed Getter: filMisc1
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * 
    * @return  filMisc1
    */
   public integer getFilMisc1(int index)
   {
      return composite8.get(index).getFilMisc1();
   }

   /**
    * Indexed Setter: filMisc1
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * @param   element
    *          filMisc1
    */
   public void setFilMisc1(int index, NumberType element)
   {
      composite8.get(index).setFilMisc1(element);
   }

   /**
    * Indexed Getter: filMisc2
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * 
    * @return  filMisc2
    */
   public character getFilMisc2(int index)
   {
      return composite8.get(index).getFilMisc2();
   }

   /**
    * Indexed Setter: filMisc2
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * @param   element
    *          filMisc2
    */
   public void setFilMisc2(int index, Text element)
   {
      composite8.get(index).setFilMisc2(element);
   }

   /**
    * Getter: lastChange
    * 
    * @return  lastChange
    */
   public integer getLastChange()
   {
      return (new integer(lastChange));
   }

   /**
    * Setter: lastChange
    * 
    * @param   lastChange
    *          lastChange
    */
   public void setLastChange(NumberType lastChange)
   {
      this.lastChange.assign(lastChange);
   }

   /**
    * Getter: dbLang
    * 
    * @return  dbLang
    */
   public integer getDbLang()
   {
      return (new integer(dbLang));
   }

   /**
    * Setter: dbLang
    * 
    * @param   dbLang
    *          dbLang
    */
   public void setDbLang(NumberType dbLang)
   {
      this.dbLang.assign(dbLang);
   }

   /**
    * Getter: hidden
    * 
    * @return  hidden
    */
   public logical isHidden()
   {
      return (new logical(hidden));
   }

   /**
    * Setter: hidden
    * 
    * @param   hidden
    *          hidden
    */
   public void setHidden(logical hidden)
   {
      this.hidden.assign(hidden);
   }

   /**
    * Getter: Frozen
    * 
    * @return  Frozen
    */
   public logical isFrozen()
   {
      return (new logical(frozen));
   }

   /**
    * Setter: Frozen
    * 
    * @param   frozen
    *          Frozen
    */
   public void setFrozen(logical frozen)
   {
      this.frozen.assign(frozen);
   }

   /**
    * Getter: Dump-name
    * 
    * @return  Dump-name
    */
   public character getDumpName()
   {
      return (new character(dumpName));
   }

   /**
    * Setter: Dump-name
    * 
    * @param   dumpName
    *          Dump-name
    */
   public void setDumpName(Text dumpName)
   {
      this.dumpName.assign(dumpName);
   }

   /**
    * Getter: CRC
    * 
    * @return  CRC
    */
   public integer getCrc()
   {
      return (new integer(crc));
   }

   /**
    * Setter: CRC
    * 
    * @param   crc
    *          CRC
    */
   public void setCrc(NumberType crc)
   {
      this.crc.assign(crc);
   }

   /**
    * Indexed Getter: filRes1
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * 
    * @return  filRes1
    */
   public integer getFilRes1(int index)
   {
      return composite8.get(index).getFilRes1();
   }

   /**
    * Indexed Setter: filRes1
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * @param   element
    *          filRes1
    */
   public void setFilRes1(int index, NumberType element)
   {
      composite8.get(index).setFilRes1(element);
   }

   /**
    * Indexed Getter: filRes2
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * 
    * @return  filRes2
    */
   public character getFilRes2(int index)
   {
      return composite8.get(index).getFilRes2();
   }

   /**
    * Indexed Setter: filRes2
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * @param   element
    *          filRes2
    */
   public void setFilRes2(int index, Text element)
   {
      composite8.get(index).setFilRes2(element);
   }

   /**
    * Getter: cache
    * 
    * @return  cache
    */
   public raw getCache()
   {
      return (new raw(cache));
   }

   /**
    * Setter: cache
    * 
    * @param   cache
    *          cache
    */
   public void setCache(BinaryData cache)
   {
      this.cache.assign(cache);
   }

   /**
    * Getter: forSize
    * 
    * @return  forSize
    */
   public integer getForSize()
   {
      return (new integer(forSize));
   }

   /**
    * Setter: forSize
    * 
    * @param   forSize
    *          forSize
    */
   public void setForSize(NumberType forSize)
   {
      this.forSize.assign(forSize);
   }

   /**
    * Getter: forFlag
    * 
    * @return  forFlag
    */
   public integer getForFlag()
   {
      return (new integer(forFlag));
   }

   /**
    * Setter: forFlag
    * 
    * @param   forFlag
    *          forFlag
    */
   public void setForFlag(NumberType forFlag)
   {
      this.forFlag.assign(forFlag);
   }

   /**
    * Getter: forCnt1
    * 
    * @return  forCnt1
    */
   public integer getForCnt1()
   {
      return (new integer(forCnt1));
   }

   /**
    * Setter: forCnt1
    * 
    * @param   forCnt1
    *          forCnt1
    */
   public void setForCnt1(NumberType forCnt1)
   {
      this.forCnt1.assign(forCnt1);
   }

   /**
    * Getter: forCnt2
    * 
    * @return  forCnt2
    */
   public integer getForCnt2()
   {
      return (new integer(forCnt2));
   }

   /**
    * Setter: forCnt2
    * 
    * @param   forCnt2
    *          forCnt2
    */
   public void setForCnt2(NumberType forCnt2)
   {
      this.forCnt2.assign(forCnt2);
   }

   /**
    * Getter: forName
    * 
    * @return  forName
    */
   public character getForName()
   {
      return (new character(forName));
   }

   /**
    * Setter: forName
    * 
    * @param   forName
    *          forName
    */
   public void setForName(Text forName)
   {
      this.forName.assign(forName);
   }

   /**
    * Getter: forOwner
    * 
    * @return  forOwner
    */
   public character getForOwner()
   {
      return (new character(forOwner));
   }

   /**
    * Setter: forOwner
    * 
    * @param   forOwner
    *          forOwner
    */
   public void setForOwner(Text forOwner)
   {
      this.forOwner.assign(forOwner);
   }

   /**
    * Getter: forFormat
    * 
    * @return  forFormat
    */
   public character getForFormat()
   {
      return (new character(forFormat));
   }

   /**
    * Setter: forFormat
    * 
    * @param   forFormat
    *          forFormat
    */
   public void setForFormat(Text forFormat)
   {
      this.forFormat.assign(forFormat);
   }

   /**
    * Getter: forInfo
    * 
    * @return  forInfo
    */
   public character getForInfo()
   {
      return (new character(forInfo));
   }

   /**
    * Setter: forInfo
    * 
    * @param   forInfo
    *          forInfo
    */
   public void setForInfo(Text forInfo)
   {
      this.forInfo.assign(forInfo);
   }

   /**
    * Getter: forType
    * 
    * @return  forType
    */
   public character getForType()
   {
      return (new character(forType));
   }

   /**
    * Setter: forType
    * 
    * @param   forType
    *          forType
    */
   public void setForType(Text forType)
   {
      this.forType.assign(forType);
   }

   /**
    * Getter: forId
    * 
    * @return  forId
    */
   public integer getForId()
   {
      return (new integer(forId));
   }

   /**
    * Setter: forId
    * 
    * @param   forId
    *          forId
    */
   public void setForId(NumberType forId)
   {
      this.forId.assign(forId);
   }

   /**
    * Getter: forNumber
    * 
    * @return  forNumber
    */
   public integer getForNumber()
   {
      return (new integer(forNumber));
   }

   /**
    * Setter: forNumber
    * 
    * @param   forNumber
    *          forNumber
    */
   public void setForNumber(NumberType forNumber)
   {
      this.forNumber.assign(forNumber);
   }

   /**
    * Getter: File-Label
    * 
    * @return  File-Label
    */
   public character getFileLabel()
   {
      return (new character(fileLabel));
   }

   /**
    * Setter: File-Label
    * 
    * @param   fileLabel
    *          File-Label
    */
   public void setFileLabel(Text fileLabel)
   {
      this.fileLabel.assign(fileLabel);
   }

   /**
    * Getter: Can-Dump
    * 
    * @return  Can-Dump
    */
   public character getCanDump()
   {
      return (new character(canDump));
   }

   /**
    * Setter: Can-Dump
    * 
    * @param   canDump
    *          Can-Dump
    */
   public void setCanDump(Text canDump)
   {
      this.canDump.assign(canDump);
   }

   /**
    * Getter: Can-Load
    * 
    * @return  Can-Load
    */
   public character getCanLoad()
   {
      return (new character(canLoad));
   }

   /**
    * Setter: Can-Load
    * 
    * @param   canLoad
    *          Can-Load
    */
   public void setCanLoad(Text canLoad)
   {
      this.canLoad.assign(canLoad);
   }

   /**
    * Getter: Valmsg-SA
    * 
    * @return  Valmsg-SA
    */
   public character getValmsgSa()
   {
      return (new character(valmsgSa));
   }

   /**
    * Setter: Valmsg-SA
    * 
    * @param   valmsgSa
    *          Valmsg-SA
    */
   public void setValmsgSa(Text valmsgSa)
   {
      this.valmsgSa.assign(valmsgSa);
   }

   /**
    * Getter: File-Label-SA
    * 
    * @return  File-Label-SA
    */
   public character getFileLabelSa()
   {
      return (new character(fileLabelSa));
   }

   /**
    * Setter: File-Label-SA
    * 
    * @param   fileLabelSa
    *          File-Label-SA
    */
   public void setFileLabelSa(Text fileLabelSa)
   {
      this.fileLabelSa.assign(fileLabelSa);
   }

   /**
    * Getter: ianum
    * 
    * @return  ianum
    */
   public integer getIanum()
   {
      return (new integer(ianum));
   }

   /**
    * Setter: ianum
    * 
    * @param   ianum
    *          ianum
    */
   public void setIanum(NumberType ianum)
   {
      this.ianum.assign(ianum);
   }

   /**
    * Getter: version
    * 
    * @return  version
    */
   public integer getVersion()
   {
      return (new integer(version));
   }

   /**
    * Setter: version
    * 
    * @param   version
    *          version
    */
   public void setVersion(NumberType version)
   {
      this.version.assign(version);
   }

   /**
    * Getter: fieldMap
    * 
    * @return  fieldMap
    */
   public raw getFieldMap()
   {
      return (new raw(fieldMap));
   }

   /**
    * Setter: fieldMap
    * 
    * @param   fieldMap
    *          fieldMap
    */
   public void setFieldMap(BinaryData fieldMap)
   {
      this.fieldMap.assign(fieldMap);
   }

   /**
    * Getter: Creator
    * 
    * @return  Creator
    */
   public character getCreator()
   {
      return (new character(creator));
   }

   /**
    * Setter: Creator
    * 
    * @param   creator
    *          Creator
    */
   public void setCreator(Text creator)
   {
      this.creator.assign(creator);
   }

   /**
    * Getter: hasCcnstrs
    * 
    * @return  hasCcnstrs
    */
   public character getHasCcnstrs()
   {
      return (new character(hasCcnstrs));
   }

   /**
    * Setter: hasCcnstrs
    * 
    * @param   hasCcnstrs
    *          hasCcnstrs
    */
   public void setHasCcnstrs(Text hasCcnstrs)
   {
      this.hasCcnstrs.assign(hasCcnstrs);
   }

   /**
    * Getter: hasFcnstrs
    * 
    * @return  hasFcnstrs
    */
   public character getHasFcnstrs()
   {
      return (new character(hasFcnstrs));
   }

   /**
    * Setter: hasFcnstrs
    * 
    * @param   hasFcnstrs
    *          hasFcnstrs
    */
   public void setHasFcnstrs(Text hasFcnstrs)
   {
      this.hasFcnstrs.assign(hasFcnstrs);
   }

   /**
    * Getter: hasPcnstrs
    * 
    * @return  hasPcnstrs
    */
   public character getHasPcnstrs()
   {
      return (new character(hasPcnstrs));
   }

   /**
    * Setter: hasPcnstrs
    * 
    * @param   hasPcnstrs
    *          hasPcnstrs
    */
   public void setHasPcnstrs(Text hasPcnstrs)
   {
      this.hasPcnstrs.assign(hasPcnstrs);
   }

   /**
    * Getter: hasUcnstrs
    * 
    * @return  hasUcnstrs
    */
   public character getHasUcnstrs()
   {
      return (new character(hasUcnstrs));
   }

   /**
    * Setter: hasUcnstrs
    * 
    * @param   hasUcnstrs
    *          hasUcnstrs
    */
   public void setHasUcnstrs(Text hasUcnstrs)
   {
      this.hasUcnstrs.assign(hasUcnstrs);
   }

   /**
    * Getter: Owner
    * 
    * @return  Owner
    */
   public character getOwner()
   {
      return (new character(owner));
   }

   /**
    * Setter: Owner
    * 
    * @param   owner
    *          Owner
    */
   public void setOwner(Text owner)
   {
      this.owner.assign(owner);
   }

   /**
    * Getter: rssid
    * 
    * @return  rssid
    */
   public integer getRssid()
   {
      return (new integer(rssid));
   }

   /**
    * Setter: rssid
    * 
    * @param   rssid
    *          rssid
    */
   public void setRssid(NumberType rssid)
   {
      this.rssid.assign(rssid);
   }

   /**
    * Getter: tblStatus
    * 
    * @return  tblStatus
    */
   public character getTblStatus()
   {
      return (new character(tblStatus));
   }

   /**
    * Setter: tblStatus
    * 
    * @param   tblStatus
    *          tblStatus
    */
   public void setTblStatus(Text tblStatus)
   {
      this.tblStatus.assign(tblStatus);
   }

   /**
    * Getter: Tbl-Type
    * 
    * @return  Tbl-Type
    */
   public character getTblType()
   {
      return (new character(tblType));
   }

   /**
    * Setter: Tbl-Type
    * 
    * @param   tblType
    *          Tbl-Type
    */
   public void setTblType(Text tblType)
   {
      this.tblType.assign(tblType);
   }

   /**
    * Getter: User-Misc
    * 
    * @return  User-Misc
    */
   public character getUserMisc()
   {
      return (new character(userMisc));
   }

   /**
    * Setter: User-Misc
    * 
    * @param   userMisc
    *          User-Misc
    */
   public void setUserMisc(Text userMisc)
   {
      this.userMisc.assign(userMisc);
   }

   /**
    * Getter: lastModified
    * 
    * @return  lastModified
    */
   public datetimetz getLastModified()
   {
      return (new datetimetz(lastModified));
   }

   /**
    * Setter: lastModified
    * 
    * @param   lastModified
    *          lastModified
    */
   public void setLastModified(date lastModified)
   {
      this.lastModified.assign(lastModified);
   }

   /**
    * Getter: modSequence
    * 
    * @return  modSequence
    */
   public integer getModSequence()
   {
      return (new integer(modSequence));
   }

   /**
    * Setter: modSequence
    * 
    * @param   modSequence
    *          modSequence
    */
   public void setModSequence(NumberType modSequence)
   {
      this.modSequence.assign(modSequence);
   }

   /**
    * Inner class which composites properties of like extent. All properties migrated from the
    * legacy table <code>_meta._file</code> of extent 8 are data members of this class.
    */
   static class Composite8
   implements Serializable
   {
      /** Data member */
      @LegacyField(fieldId = 19, name = "_fil-misc1", format = ">>>9", initial = "?", order = 19, extent = 8)
      private final integer filMisc1;

      /** Data member */
      @LegacyField(fieldId = 20, name = "_fil-misc2", format = "x(12)", initial = "?", order = 20, extent = 8)
      private final character filMisc2;

      /** Data member */
      @LegacyField(fieldId = 27, name = "_fil-res1", format = ">>>9", initial = "?", order = 27, extent = 8)
      private final integer filRes1;

      /** Data member */
      @LegacyField(fieldId = 28, name = "_fil-res2", format = "x(12)", initial = "?", order = 28, extent = 8)
      private final character filRes2;

      /**
       * Default constructor.
       */
      public Composite8()
      {
         filMisc1 = new integer();
         filMisc2 = new character("?");
         filRes1 = new integer();
         filRes2 = new character("?");
      }

      /**
       * Getter: filMisc1
       * 
       * @return  filMisc1
       */
      public integer getFilMisc1()
      {
         return (new integer(filMisc1));
      }

      /**
       * Setter: filMisc1
       * 
       * @param   filMisc1
       *          filMisc1
       */
      public void setFilMisc1(NumberType filMisc1)
      {
         this.filMisc1.assign(filMisc1);
      }

      /**
       * Getter: filMisc2
       * 
       * @return  filMisc2
       */
      public character getFilMisc2()
      {
         return (new character(filMisc2));
      }

      /**
       * Setter: filMisc2
       * 
       * @param   filMisc2
       *          filMisc2
       */
      public void setFilMisc2(Text filMisc2)
      {
         this.filMisc2.assign(filMisc2);
      }

      /**
       * Getter: filRes1
       * 
       * @return  filRes1
       */
      public integer getFilRes1()
      {
         return (new integer(filRes1));
      }

      /**
       * Setter: filRes1
       * 
       * @param   filRes1
       *          filRes1
       */
      public void setFilRes1(NumberType filRes1)
      {
         this.filRes1.assign(filRes1);
      }

      /**
       * Getter: filRes2
       * 
       * @return  filRes2
       */
      public character getFilRes2()
      {
         return (new character(filRes2));
      }

      /**
       * Setter: filRes2
       * 
       * @param   filRes2
       *          filRes2
       */
      public void setFilRes2(Text filRes2)
      {
         this.filRes2.assign(filRes2);
      }
   }
}
