package com.goldencode.hotel.dmo.hotel;

import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;

/**
 * Data Model Object corresponding with table <code>hotel.meta_user</code> (previously
 * <code>hotel._user</code>).
 */
public interface MetaUser
extends DataModelObject
{
   /**
    * Getter: Userid
    * 
    * @return  Userid
    */
   public character getUserid();

   /**
    * Setter: Userid
    * 
    * @param   userid
    *          Userid
    */
   public void setUserid(Text userid);

   /**
    * Getter: Password
    * 
    * @return  Password
    */
   public character getPassword();

   /**
    * Setter: Password
    * 
    * @param   password
    *          Password
    */
   public void setPassword(Text password);

   /**
    * Getter: User-Name
    * 
    * @return  User-Name
    */
   public character getUserName();

   /**
    * Setter: User-Name
    * 
    * @param   userName
    *          User-Name
    */
   public void setUserName(Text userName);

   /**
    * Indexed Getter: UMisc1
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * 
    * @return  UMisc1
    */
   public integer getUMisc1(int index);

   /**
    * Indexed Setter: UMisc1
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * @param   element
    *          UMisc1
    */
   public void setUMisc1(int index, NumberType element);

   /**
    * Indexed Getter: UMisc2
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * 
    * @return  UMisc2
    */
   public character getUMisc2(int index);

   /**
    * Indexed Setter: UMisc2
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * @param   element
    *          UMisc2
    */
   public void setUMisc2(int index, Text element);

   /**
    * Getter: User-Misc
    * 
    * @return  User-Misc
    */
   public character getUserMisc();

   /**
    * Setter: User-Misc
    * 
    * @param   userMisc
    *          User-Misc
    */
   public void setUserMisc(Text userMisc);

   /**
    * Getter: User_number
    * 
    * @return  User_number
    */
   public integer getUserNumber();

   /**
    * Setter: User_number
    * 
    * @param   userNumber
    *          User_number
    */
   public void setUserNumber(NumberType userNumber);

   /**
    * Getter: Group_number
    * 
    * @return  Group_number
    */
   public integer getGroupNumber();

   /**
    * Setter: Group_number
    * 
    * @param   groupNumber
    *          Group_number
    */
   public void setGroupNumber(NumberType groupNumber);

   /**
    * Getter: Given_name
    * 
    * @return  Given_name
    */
   public character getGivenName();

   /**
    * Setter: Given_name
    * 
    * @param   givenName
    *          Given_name
    */
   public void setGivenName(Text givenName);

   /**
    * Getter: Middle_initial
    * 
    * @return  Middle_initial
    */
   public character getMiddleInitial();

   /**
    * Setter: Middle_initial
    * 
    * @param   middleInitial
    *          Middle_initial
    */
   public void setMiddleInitial(Text middleInitial);

   /**
    * Getter: Surname
    * 
    * @return  Surname
    */
   public character getSurname();

   /**
    * Setter: Surname
    * 
    * @param   surname
    *          Surname
    */
   public void setSurname(Text surname);

   /**
    * Getter: Telephone
    * 
    * @return  Telephone
    */
   public character getTelephone();

   /**
    * Setter: Telephone
    * 
    * @param   telephone
    *          Telephone
    */
   public void setTelephone(Text telephone);

   /**
    * Getter: Email
    * 
    * @return  Email
    */
   public character getEmail();

   /**
    * Setter: Email
    * 
    * @param   email
    *          Email
    */
   public void setEmail(Text email);

   /**
    * Getter: Description
    * 
    * @return  Description
    */
   public character getDescription();

   /**
    * Setter: Description
    * 
    * @param   description
    *          Description
    */
   public void setDescription(Text description);

   /**
    * Getter: Disabled
    * 
    * @return  Disabled
    */
   public logical isDisabled();

   /**
    * Setter: Disabled
    * 
    * @param   disabled
    *          Disabled
    */
   public void setDisabled(logical disabled);

   /**
    * Getter: Create_date
    * 
    * @return  Create_date
    */
   public datetimetz getCreateDate();

   /**
    * Setter: Create_date
    * 
    * @param   createDate
    *          Create_date
    */
   public void setCreateDate(date createDate);

   /**
    * Getter: Account_expires
    * 
    * @return  Account_expires
    */
   public datetimetz getAccountExpires();

   /**
    * Setter: Account_expires
    * 
    * @param   accountExpires
    *          Account_expires
    */
   public void setAccountExpires(date accountExpires);

   /**
    * Getter: Pwd_expires
    * 
    * @return  Pwd_expires
    */
   public datetimetz getPwdExpires();

   /**
    * Setter: Pwd_expires
    * 
    * @param   pwdExpires
    *          Pwd_expires
    */
   public void setPwdExpires(date pwdExpires);

   /**
    * Getter: Pwd_duration
    * 
    * @return  Pwd_duration
    */
   public integer getPwdDuration();

   /**
    * Setter: Pwd_duration
    * 
    * @param   pwdDuration
    *          Pwd_duration
    */
   public void setPwdDuration(NumberType pwdDuration);

   /**
    * Getter: Last_login
    * 
    * @return  Last_login
    */
   public datetimetz getLastLogin();

   /**
    * Setter: Last_login
    * 
    * @param   lastLogin
    *          Last_login
    */
   public void setLastLogin(date lastLogin);

   /**
    * Getter: Logins
    * 
    * @return  Logins
    */
   public integer getLogins();

   /**
    * Setter: Logins
    * 
    * @param   logins
    *          Logins
    */
   public void setLogins(NumberType logins);

   /**
    * Getter: Max_logins
    * 
    * @return  Max_logins
    */
   public integer getMaxLogins();

   /**
    * Setter: Max_logins
    * 
    * @param   maxLogins
    *          Max_logins
    */
   public void setMaxLogins(NumberType maxLogins);

   /**
    * Getter: Max_tries
    * 
    * @return  Max_tries
    */
   public integer getMaxTries();

   /**
    * Setter: Max_tries
    * 
    * @param   maxTries
    *          Max_tries
    */
   public void setMaxTries(NumberType maxTries);

   /**
    * Getter: Login_failures
    * 
    * @return  Login_failures
    */
   public integer getLoginFailures();

   /**
    * Setter: Login_failures
    * 
    * @param   loginFailures
    *          Login_failures
    */
   public void setLoginFailures(NumberType loginFailures);

   /**
    * Getter: Spare1
    * 
    * @return  Spare1
    */
   public integer getSpare1();

   /**
    * Setter: Spare1
    * 
    * @param   spare1
    *          Spare1
    */
   public void setSpare1(NumberType spare1);

   /**
    * Getter: Spare2
    * 
    * @return  Spare2
    */
   public integer getSpare2();

   /**
    * Setter: Spare2
    * 
    * @param   spare2
    *          Spare2
    */
   public void setSpare2(NumberType spare2);

   /**
    * Getter: Spare3
    * 
    * @return  Spare3
    */
   public character getSpare3();

   /**
    * Setter: Spare3
    * 
    * @param   spare3
    *          Spare3
    */
   public void setSpare3(Text spare3);

   /**
    * Getter: Spare4
    * 
    * @return  Spare4
    */
   public character getSpare4();

   /**
    * Setter: Spare4
    * 
    * @param   spare4
    *          Spare4
    */
   public void setSpare4(Text spare4);

   /**
    * DMO interface for use by converted business logic.
    */
   public interface Buf
   extends MetaUser, Buffer
   {
      /**
       * Getter: UMisc1
       * 
       * @return  UMisc1
       */
      public integer[] getUMisc1();

      /**
       * Indexed Getter: UMisc1
       * 
       * @param   index
       *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
       * 
       * @return  UMisc1
       */
      public integer getUMisc1(NumberType index);

      /**
       * Indexed Setter: UMisc1
       * 
       * @param   index
       *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
       * @param   element
       *          UMisc1
       */
      public void setUMisc1(NumberType index, NumberType element);

      /**
       * Set all elements of the target list property to the given scalar value. Modifies the
       * contents of: UMisc1
       * 
       * @param   element
       *          Scalar value to which to set all elements of: UMisc1
       */
      public void setUMisc1(NumberType element);

      /**
       * Set as many elements of the target list property as are provided in the given array of
       * scalar values. Modifies the contents of: UMisc1
       * <p>
       * If the given array is larger than the target list, any additional elements in the given
       * array are ignored. If the target array is smaller than the target list, only those
       * elements whose array indices match are updated.
       * 
       * @param   elements
       *          Array of scalar values to which to set the corresponding elements of: UMisc1
       */
      public void setUMisc1(NumberType[] elements);

      /**
       * Getter: UMisc2
       * 
       * @return  UMisc2
       */
      public character[] getUMisc2();

      /**
       * Indexed Getter: UMisc2
       * 
       * @param   index
       *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
       * 
       * @return  UMisc2
       */
      public character getUMisc2(NumberType index);

      /**
       * Indexed Setter: UMisc2
       * 
       * @param   index
       *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
       * @param   element
       *          UMisc2
       */
      public void setUMisc2(NumberType index, Text element);

      /**
       * Set all elements of the target list property to the given scalar value. Modifies the
       * contents of: UMisc2
       * 
       * @param   element
       *          Scalar value to which to set all elements of: UMisc2
       */
      public void setUMisc2(Text element);

      /**
       * Set as many elements of the target list property as are provided in the given array of
       * scalar values. Modifies the contents of: UMisc2
       * <p>
       * If the given array is larger than the target list, any additional elements in the given
       * array are ignored. If the target array is smaller than the target list, only those
       * elements whose array indices match are updated.
       * 
       * @param   elements
       *          Array of scalar values to which to set the corresponding elements of: UMisc2
       */
      public void setUMisc2(Text[] elements);

   }
}
