package com.goldencode.hotel.dmo.hotel;

import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;

/**
 * Data Model Object corresponding with table <code>hotel.reservation</code> (previously
 * <code>hotel.reservation</code>).
 */
public interface Reservation
extends DataModelObject
{
   /**
    * Getter: Reservation Number
    * 
    * @return  Reservation Number
    */
   public integer getReservationId();

   /**
    * Setter: Reservation Number
    * 
    * @param   reservationId
    *          Reservation Number
    */
   public void setReservationId(NumberType reservationId);

   /**
    * Getter: Discount %
    * 
    * @return  Discount %
    */
   public decimal getDiscount();

   /**
    * Setter: Discount %
    * 
    * @param   discount
    *          Discount %
    */
   public void setDiscount(NumberType discount);

   /**
    * Getter: Date
    * 
    * @return  Date
    */
   public date getDateValue();

   /**
    * Setter: Date
    * 
    * @param   dateValue
    *          Date
    */
   public void setDateValue(date dateValue);

   /**
    * Getter: Checkin
    * 
    * @return  Checkin
    */
   public date getCheckin();

   /**
    * Setter: Checkin
    * 
    * @param   checkin
    *          Checkin
    */
   public void setCheckin(date checkin);

   /**
    * Getter: Checkout
    * 
    * @return  Checkout
    */
   public date getCheckout();

   /**
    * Setter: Checkout
    * 
    * @param   checkout
    *          Checkout
    */
   public void setCheckout(date checkout);

   /**
    * Getter: Guest ID
    * 
    * @return  Guest ID
    */
   public integer getGuestId();

   /**
    * Setter: Guest ID
    * 
    * @param   guestId
    *          Guest ID
    */
   public void setGuestId(NumberType guestId);

   /**
    * Getter: Details
    * 
    * @return  Details
    */
   public character getDetails();

   /**
    * Setter: Details
    * 
    * @param   details
    *          Details
    */
   public void setDetails(Text details);

   /**
    * Getter: State
    * 
    * @return  State
    */
   public character getState();

   /**
    * Setter: State
    * 
    * @param   state
    *          State
    */
   public void setState(Text state);

   /**
    * DMO interface for use by converted business logic.
    */
   public interface Buf
   extends Reservation, Buffer
   {
   }
}
