package com.goldencode.hotel.dmo.hotel;

import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;

/**
 * Data Model Object corresponding with table <code>hotel.room_state</code> (previously
 * <code>hotel.room-state</code>).
 */
public interface RoomState
extends DataModelObject
{
   /**
    * Getter: Room Number
    * 
    * @return  Room Number
    */
   public integer getRoomNumber();

   /**
    * Setter: Room Number
    * 
    * @param   roomNumber
    *          Room Number
    */
   public void setRoomNumber(NumberType roomNumber);

   /**
    * Getter: Room State
    * 
    * @return  Room State
    */
   public logical isState();

   /**
    * Setter: Room State
    * 
    * @param   state
    *          Room State
    */
   public void setState(logical state);

   /**
    * Getter: Date
    * 
    * @return  Date
    */
   public date getStartDate();

   /**
    * Setter: Date
    * 
    * @param   startDate
    *          Date
    */
   public void setStartDate(date startDate);

   /**
    * DMO interface for use by converted business logic.
    */
   public interface Buf
   extends RoomState, Buffer
   {
   }
}
